<?php
/*
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

   ---------------------------------------------------------------------
   Gerrit Bouweriks
   Dutch DHL Parcel + International Shipping
   OpenCart 3.0.2.0
   Special thank you goes to
   Roelie of PprMkr for helping me out.
   SuperJuice (Sam), for conversions made to weight en length classes
   Sanne, Gijs and Cliff for testing and Norman for the translations
   Petran for old letterbox solution
   This new version uses a modified boxing.class.php as a letterbox solution.
   I was pointed out to this class by Ivo, another Dutch OpenCart user.
   https://github.com/yetzt/boxing/blob/master/boxing.class.php
*/
class ControllerExtensionShippingDHLparcel extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('extension/shipping/dhlparcel');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('shipping_dhlparcel', $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=shipping', true));
		}
	
	
		$data['heading_title'] = $this->language->get('heading_title');
		
		$data['text_edit'] = $this->language->get('text_edit');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');
		$data['text_all_zones'] = $this->language->get('text_all_zones');
		$data['text_none'] = $this->language->get('text_none');

		$data['entry_total'] = $this->language->get('entry_total');
		
		$data['text_help_nl_homeaddress'] = $this->language->get('text_help_nl_homeaddress');
		
		$data['text_shipto'] = $this->language->get('text_shipto');
		
		$data['text_help_nl_mailbox'] = $this->language->get('text_help_nl_mailbox');
		$data['text_help_nl_verysmall'] = $this->language->get('text_help_nl_verysmall');
		$data['text_help_nl_small'] = $this->language->get('text_help_nl_small');
		$data['text_help_nl_medium'] = $this->language->get('text_help_nl_medium');
		$data['text_help_nl_large'] = $this->language->get('text_help_nl_large');
		
		$data['text_help_mailbox'] = $this->language->get('text_help_mailbox');	
		$data['text_help_verysmall'] = $this->language->get('text_help_verysmall');	
		$data['text_help_small'] = $this->language->get('text_help_small');
		$data['text_help_medium'] = $this->language->get('text_help_medium');
		$data['text_help_large'] = $this->language->get('text_help_large');
			
		$data['text_none'] = $this->language->get('text_none');
		$data['text_yes'] = $this->language->get('text_yes');
		$data['text_no'] = $this->language->get('text_no');

		// Netherlands
		$data['entry_netherlands_cost_homeaddress'] = $this->language->get('entry_netherlands_cost_homeaddress');
		$data['entry_netherlands_cost_mailbox'] = $this->language->get('entry_netherlands_cost_mailbox');
		$data['entry_netherlands_cost_verysmall'] = $this->language->get('entry_netherlands_cost_verysmall');
		$data['entry_netherlands_cost_small'] = $this->language->get('entry_netherlands_cost_small');
		$data['entry_netherlands_cost_medium'] = $this->language->get('entry_netherlands_cost_medium');
		$data['entry_netherlands_cost_large'] = $this->language->get('entry_netherlands_cost_large');
		
		// Germany
		$data['entry_zone1_cost_mailbox_zone1A'] = $this->language->get('entry_zone1_cost_mailbox_zone1A');
		$data['entry_zone1_cost_verysmall_zone1A'] = $this->language->get('entry_zone1_cost_verysmall_zone1A');
		$data['entry_zone1_cost_small_zone1A'] = $this->language->get('entry_zone1_cost_small_zone1A');
		$data['entry_zone1_cost_medium_zone1A'] = $this->language->get('entry_zone1_cost_medium_zone1A');
		$data['entry_zone1_cost_large_zone1A'] = $this->language->get('entry_zone1_cost_large_zone1A');
		
		// Belgium - Luxembourg	
		$data['entry_zone1_cost_mailbox_zone1B'] = $this->language->get('entry_zone1_cost_mailbox_zone1B');
		$data['entry_zone1_cost_verysmall_zone1B'] = $this->language->get('entry_zone1_cost_verysmall_zone1B');
		$data['entry_zone1_cost_small_zone1B'] = $this->language->get('entry_zone1_cost_small_zone1B');
		$data['entry_zone1_cost_medium_zone1B'] = $this->language->get('entry_zone1_cost_medium_zone1B');
		$data['entry_zone1_cost_large_zone1B'] = $this->language->get('entry_zone1_cost_large_zone1B');
		
		// Denmark, France, United Kingdom, Italy, Austria, Sweden
		$data['entry_zone1_cost_mailbox_zone1C'] = $this->language->get('entry_zone1_cost_mailbox_zone1C');
		$data['entry_zone1_cost_verysmall_zone1C'] = $this->language->get('entry_zone1_cost_verysmall_zone1C');
		$data['entry_zone1_cost_small_zone1C'] = $this->language->get('entry_zone1_cost_small_zone1C');
		$data['entry_zone1_cost_medium_zone1C'] = $this->language->get('entry_zone1_cost_medium_zone1C');
		$data['entry_zone1_cost_large_zone1C'] = $this->language->get('entry_zone1_cost_large_zone1C');
		
		// Finland, Ireland, Poland, Portugal
		$data['entry_zone1_cost_mailbox_zone1D'] = $this->language->get('entry_zone1_cost_mailbox_zone1D');
		$data['entry_zone1_cost_verysmall_zone1D'] = $this->language->get('entry_zone1_cost_verysmall_zone1D');
		$data['entry_zone1_cost_small_zone1D'] = $this->language->get('entry_zone1_cost_small_zone1D');
		$data['entry_zone1_cost_medium_zone1D'] = $this->language->get('entry_zone1_cost_medium_zone1D');
		$data['entry_zone1_cost_large_zone1D'] = $this->language->get('entry_zone1_cost_large_zone1D');
		
		// Spain	
		$data['entry_zone1_cost_mailbox_zone1E'] = $this->language->get('entry_zone1_cost_mailbox_zone1E');
		$data['entry_zone1_cost_verysmall_zone1E'] = $this->language->get('entry_zone1_cost_verysmall_zone1E');
		$data['entry_zone1_cost_small_zone1E'] = $this->language->get('entry_zone1_cost_small_zone1E');
		$data['entry_zone1_cost_medium_zone1E'] = $this->language->get('entry_zone1_cost_medium_zone1E');
		$data['entry_zone1_cost_large_zone1E'] = $this->language->get('entry_zone1_cost_large_zone1E');
		
		// Europe Zone 2
		$data['entry_zone2_cost_mailbox'] = $this->language->get('entry_zone2_cost_mailbox');
		$data['entry_zone2_cost_small'] = $this->language->get('entry_zone2_cost_verysmall');
		$data['entry_zone2_cost_small'] = $this->language->get('entry_zone2_cost_small');
		$data['entry_zone2_cost_medium'] = $this->language->get('entry_zone2_cost_medium');
		$data['entry_zone2_cost_large'] = $this->language->get('entry_zone2_cost_large');
		
		// Norway, Switserland
		$data['entry_zone2_cost_mailbox_zone2a'] = $this->language->get('entry_zone2_cost_mailbox_zone2a');
		
		// Vatican City
		$data['entry_zone2_cost_mailbox_zone2b'] = $this->language->get('entry_zone2_cost_mailbox_zone2b');
		
		// ROW Zone 3
		$data['entry_zone3_cost_mailbox'] = $this->language->get('entry_zone3_cost_mailbox');
		$data['entry_zone3_cost_verysmall'] = $this->language->get('entry_zone3_cost_verysmall');
		$data['entry_zone3_cost_small'] = $this->language->get('entry_zone3_cost_small');
		$data['entry_zone3_cost_medium'] = $this->language->get('entry_zone3_cost_medium');
		$data['entry_zone3_cost_large'] = $this->language->get('entry_zone3_cost_large');

		$data['entry_use_freeshipping'] = $this->language->get('entry_use_freeshipping');
		$data['entry_use_mailbox'] = $this->language->get('entry_use_mailbox');
		$data['entry_tax_class'] = $this->language->get('entry_tax_class');
		$data['entry_geo_zone'] = $this->language->get('entry_geo_zone');
		$data['entry_status'] = $this->language->get('entry_status');
		$data['entry_sort_order'] = $this->language->get('entry_sort_order');
			
		$data['help_use_freeshipping'] = $this->language->get('help_use_freeshipping');
		$data['help_use_mailbox'] = $this->language->get('help_use_mailbox');
		
		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');
		
		$data['flag_netherlands'] = $this->language->get('flag_netherlands');
		$data['flag_europe_zone_1'] = $this->language->get('flag_europe_zone_1');
		$data['flag_europe_zone_2'] = $this->language->get('flag_europe_zone_2');
		$data['flag_world'] = $this->language->get('flag_world');
		
		$data['flag_europe_zone_1A'] = $this->language->get('flag_europe_zone_1A');
		$data['flag_europe_zone_1B'] = $this->language->get('flag_europe_zone_1B');
		$data['flag_europe_zone_1C'] = $this->language->get('flag_europe_zone_1C');
		$data['flag_europe_zone_1D'] = $this->language->get('flag_europe_zone_1D');
		$data['flag_europe_zone_1E'] = $this->language->get('flag_europe_zone_1E');
		
		$data['flag_germany'] = $this->language->get('flag_germany');
		$data['flag_belgium'] = $this->language->get('flag_belgium');
		$data['flag_luxembourg'] = $this->language->get('flag_luxembourg');
		$data['flag_denmark'] = $this->language->get('flag_denmark');		
		$data['flag_france'] = $this->language->get('flag_france');
		$data['flag_united_kingdom'] = $this->language->get('flag_united_kingdom');
		$data['flag_italy'] = $this->language->get('flag_italy');
		$data['flag_austria'] = $this->language->get('flag_austria');
		$data['flag_sweden'] = $this->language->get('flag_sweden');
		$data['flag_finland'] = $this->language->get('flag_finland');
		$data['flag_ireland'] = $this->language->get('flag_ireland');
		$data['flag_poland'] = $this->language->get('flag_poland');
		$data['flag_portugal'] = $this->language->get('flag_portugal');		
		$data['flag_spain'] = $this->language->get('flag_spain');
		$data['flag_norway'] = $this->language->get('flag_norway');
		$data['flag_switzerland'] = $this->language->get('flag_switzerland');
		$data['flag_vatican_city'] = $this->language->get('flag_vatican_city');
		
		$data['icon_box_sizes'] = $this->language->get('icon_box_sizes');
		$data['icon_small_box_sizes'] = $this->language->get('icon_small_box_sizes');
		$data['icon_dhlparcel_settings'] = $this->language->get('icon_dhlparcel_settings');
		
		// Brievenbus formaten
		$data['text_help_dhlparcel_mailbox_lenght'] = $this->language->get('text_help_dhlparcel_mailbox_lenght');
		$data['text_help_dhlparcel_mailbox_width'] = $this->language->get('text_help_dhlparcel_mailbox_width');
		$data['text_help_dhlparcel_mailbox_height'] = $this->language->get('text_help_dhlparcel_mailbox_height');
		$data['text_help_dhlparcel_mailbox_weight'] = $this->language->get('text_help_dhlparcel_mailbox_weight');
		
		$data['entry_dhlparcel_mailbox_lenght'] = $this->language->get('entry_dhlparcel_mailbox_lenght');
		$data['entry_dhlparcel_mailbox_width'] = $this->language->get('entry_dhlparcel_mailbox_width');
		$data['entry_dhlparcel_mailbox_height'] = $this->language->get('entry_dhlparcel_mailbox_height');
		$data['entry_dhlparcel_mailbox_weight'] = $this->language->get('entry_dhlparcel_mailbox_weight');
		
		// verzenddoos formaten
		$data['text_help_dhlparcel_cardboard_box_lenght'] = $this->language->get('text_help_dhlparcel_cardboard_box_lenght');
		$data['text_help_dhlparcel_cardboard_box_width'] = $this->language->get('text_help_dhlparcel_cardboard_box_width');
		$data['text_help_dhlparcel_cardboard_box_height'] = $this->language->get('text_help_dhlparcel_cardboard_box_height');
		$data['text_help_dhlparcel_cardboard_box_weight'] = $this->language->get('text_help_dhlparcel_cardboard_box_weight');
		
		$data['entry_dhlparcel_cardboard_box_lenght'] = $this->language->get('entry_dhlparcel_cardboard_box_lenght');
		$data['entry_dhlparcel_cardboard_box_width'] = $this->language->get('entry_dhlparcel_cardboard_box_width');
		$data['entry_dhlparcel_cardboard_box_height'] = $this->language->get('entry_dhlparcel_cardboard_box_height');
		$data['entry_dhlparcel_cardboard_box_weight'] = $this->language->get('entry_dhlparcel_cardboard_box_weight');
		
		$data['text_countries_zone1'] = $this->language->get('text_countries_zone1');
		$data['text_countries_zone2'] = $this->language->get('text_countries_zone2');
		$data['text_countries_zone3'] = $this->language->get('text_countries_zone3');
		$data['text_countries_customs'] = $this->language->get('text_countries_customs');


 		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}
		
		$data['breadcrumbs'] = array();
		
		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=shipping', true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/shipping/dhlparcel', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['action'] = $this->url->link('extension/shipping/dhlparcel', 'user_token=' . $this->session->data['user_token'], true);

		$data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=shipping', true);
  		

		// Netherlands
		if (isset($this->request->post['shipping_dhlparcel_netherlands_cost_homeaddress'])) {
			$data['shipping_dhlparcel_netherlands_cost_homeaddress'] = $this->request->post['shipping_dhlparcel_netherlands_cost_homeaddress'];
		} else {
			$data['shipping_dhlparcel_netherlands_cost_homeaddress'] = $this->config->get('shipping_dhlparcel_netherlands_cost_homeaddress');
		}		
		
		if (isset($this->request->post['shipping_dhlparcel_netherlands_cost_mailbox'])) {
			$data['shipping_dhlparcel_netherlands_cost_mailbox'] = $this->request->post['shipping_dhlparcel_netherlands_cost_mailbox'];
		} else {
			$data['shipping_dhlparcel_netherlands_cost_mailbox'] = $this->config->get('shipping_dhlparcel_netherlands_cost_mailbox');
		}
		
		if (isset($this->request->post['shipping_dhlparcel_netherlands_cost_verysmall'])) {
			$data['shipping_dhlparcel_netherlands_cost_verysmall'] = $this->request->post['shipping_dhlparcel_netherlands_cost_verysmall'];
		} else {
			$data['shipping_dhlparcel_netherlands_cost_verysmall'] = $this->config->get('shipping_dhlparcel_netherlands_cost_verysmall');
		}
		
		if (isset($this->request->post['shipping_dhlparcel_netherlands_cost_small'])) {
			$data['shipping_dhlparcel_netherlands_cost_small'] = $this->request->post['shipping_dhlparcel_netherlands_cost_small'];
		} else {
			$data['shipping_dhlparcel_netherlands_cost_small'] = $this->config->get('shipping_dhlparcel_netherlands_cost_small');
		}
		
		if (isset($this->request->post['shipping_dhlparcel_netherlands_cost_medium'])) {
			$data['shipping_dhlparcel_netherlands_cost_medium'] = $this->request->post['shipping_dhlparcel_netherlands_cost_medium'];
		} else {
			$data['shipping_dhlparcel_netherlands_cost_medium'] = $this->config->get('shipping_dhlparcel_netherlands_cost_medium');
		}

		if (isset($this->request->post['shipping_dhlparcel_netherlands_cost_large'])) {
			$data['shipping_dhlparcel_netherlands_cost_large'] = $this->request->post['shipping_dhlparcel_netherlands_cost_large'];
		} else {
			$data['shipping_dhlparcel_netherlands_cost_large'] = $this->config->get('shipping_dhlparcel_netherlands_cost_large');
		}
		
		// Western Europe - Zone1 
		// Germany
		if (isset($this->request->post['shipping_dhlparcel_zone1_cost_mailbox_zone1A'])) {
			$data['shipping_dhlparcel_zone1_cost_mailbox_zone1A'] = $this->request->post['shipping_dhlparcel_zone1_cost_mailbox_zone1A'];
		} else {
			$data['shipping_dhlparcel_zone1_cost_mailbox_zone1A'] = $this->config->get('shipping_dhlparcel_zone1_cost_mailbox_zone1A');
		}
		
		if (isset($this->request->post['shipping_dhlparcel_zone1_cost_verysmall_zone1A'])) {
			$data['shipping_dhlparcel_zone1_cost_verysmall_zone1A'] = $this->request->post['shipping_dhlparcel_zone1_cost_verysmall_zone1A'];
		} else {
			$data['shipping_dhlparcel_zone1_cost_verysmall_zone1A'] = $this->config->get('shipping_dhlparcel_zone1_cost_verysmall_zone1A');
		}
		
		if (isset($this->request->post['shipping_dhlparcel_zone1_cost_small_zone1A'])) {
			$data['shipping_dhlparcel_zone1_cost_small_zone1A'] = $this->request->post['shipping_dhlparcel_zone1_cost_small_zone1A'];
		} else {
			$data['shipping_dhlparcel_zone1_cost_small_zone1A'] = $this->config->get('shipping_dhlparcel_zone1_cost_small_zone1A');
		}

		if (isset($this->request->post['shipping_dhlparcel_zone1_cost_medium_zone1A'])) {
			$data['shipping_dhlparcel_zone1_cost_medium_zone1A'] = $this->request->post['shipping_dhlparcel_zone1_cost_medium_zone1A'];
		} else {
			$data['shipping_dhlparcel_zone1_cost_medium_zone1A'] = $this->config->get('shipping_dhlparcel_zone1_cost_medium_zone1A');
		}
		
		if (isset($this->request->post['shipping_dhlparcel_zone1_cost_large_zone1A'])) {
			$data['shipping_dhlparcel_zone1_cost_large_zone1A'] = $this->request->post['shipping_dhlparcel_zone1_cost_large_zone1A'];
		} else {
			$data['shipping_dhlparcel_zone1_cost_large_zone1A'] = $this->config->get('shipping_dhlparcel_zone1_cost_large_zone1A');
		}
		
		// Belgium and Luxembourg
		if (isset($this->request->post['shipping_dhlparcel_zone1_cost_mailbox_zone1B'])) {
			$data['shipping_dhlparcel_zone1_cost_mailbox_zone1B'] = $this->request->post['shipping_dhlparcel_zone1_cost_mailbox_zone1B'];
		} else {
			$data['shipping_dhlparcel_zone1_cost_mailbox_zone1B'] = $this->config->get('shipping_dhlparcel_zone1_cost_mailbox_zone1B');
		}
		
		if (isset($this->request->post['shipping_dhlparcel_zone1_cost_verysmall_zone1B'])) {
			$data['shipping_dhlparcel_zone1_cost_verysmall_zone1B'] = $this->request->post['shipping_dhlparcel_zone1_cost_verysmall_zone1B'];
		} else {
			$data['shipping_dhlparcel_zone1_cost_verysmall_zone1B'] = $this->config->get('shipping_dhlparcel_zone1_cost_verysmall_zone1B');
		}
		
		if (isset($this->request->post['shipping_dhlparcel_zone1_cost_small_zone1B'])) {
			$data['shipping_dhlparcel_zone1_cost_small_zone1B'] = $this->request->post['shipping_dhlparcel_zone1_cost_small_zone1B'];
		} else {
			$data['shipping_dhlparcel_zone1_cost_small_zone1B'] = $this->config->get('shipping_dhlparcel_zone1_cost_small_zone1B');
		}

		if (isset($this->request->post['shipping_dhlparcel_zone1_cost_medium_zone1B'])) {
			$data['shipping_dhlparcel_zone1_cost_medium_zone1B'] = $this->request->post['shipping_dhlparcel_zone1_cost_medium_zone1B'];
		} else {
			$data['shipping_dhlparcel_zone1_cost_medium_zone1B'] = $this->config->get('shipping_dhlparcel_zone1_cost_medium_zone1B');
		}
		
		if (isset($this->request->post['shipping_dhlparcel_zone1_cost_large_zone1B'])) {
			$data['shipping_dhlparcel_zone1_cost_large_zone1B'] = $this->request->post['shipping_dhlparcel_zone1_cost_large_zone1B'];
		} else {
			$data['shipping_dhlparcel_zone1_cost_large_zone1B'] = $this->config->get('shipping_dhlparcel_zone1_cost_large_zone1B');
		}
		
		// Denmark, France, United Kingdom, Italy, Austria, Sweden
		if (isset($this->request->post['shipping_dhlparcel_zone1_cost_mailbox_zone1C'])) {
			$data['shipping_dhlparcel_zone1_cost_mailbox_zone1C'] = $this->request->post['shipping_dhlparcel_zone1_cost_mailbox_zone1C'];
		} else {
			$data['shipping_dhlparcel_zone1_cost_mailbox_zone1C'] = $this->config->get('shipping_dhlparcel_zone1_cost_mailbox_zone1C');
		}
		
		if (isset($this->request->post['shipping_dhlparcel_zone1_cost_verysmall_zone1C'])) {
			$data['shipping_dhlparcel_zone1_cost_verysmall_zone1C'] = $this->request->post['shipping_dhlparcel_zone1_cost_verysmall_zone1C'];
		} else {
			$data['shipping_dhlparcel_zone1_cost_verysmall_zone1C'] = $this->config->get('shipping_dhlparcel_zone1_cost_verysmall_zone1C');
		}
		
		if (isset($this->request->post['shipping_dhlparcel_zone1_cost_small_zone1C'])) {
			$data['shipping_dhlparcel_zone1_cost_small_zone1C'] = $this->request->post['shipping_dhlparcel_zone1_cost_small_zone1C'];
		} else {
			$data['shipping_dhlparcel_zone1_cost_small_zone1C'] = $this->config->get('shipping_dhlparcel_zone1_cost_small_zone1C');
		}

		if (isset($this->request->post['shipping_dhlparcel_zone1_cost_medium_zone1C'])) {
			$data['shipping_dhlparcel_zone1_cost_medium_zone1C'] = $this->request->post['shipping_dhlparcel_zone1_cost_medium_zone1C'];
		} else {
			$data['shipping_dhlparcel_zone1_cost_medium_zone1C'] = $this->config->get('shipping_dhlparcel_zone1_cost_medium_zone1C');
		}
		
		if (isset($this->request->post['shipping_dhlparcel_zone1_cost_large_zone1C'])) {
			$data['shipping_dhlparcel_zone1_cost_large_zone1C'] = $this->request->post['shipping_dhlparcel_zone1_cost_large_zone1C'];
		} else {
			$data['shipping_dhlparcel_zone1_cost_large_zone1C'] = $this->config->get('shipping_dhlparcel_zone1_cost_large_zone1C');
		}
		
		// Finland, Ireland, Poland, Portugal
		if (isset($this->request->post['shipping_dhlparcel_zone1_cost_mailbox_zone1D'])) {
			$data['shipping_dhlparcel_zone1_cost_mailbox_zone1D'] = $this->request->post['shipping_dhlparcel_zone1_cost_mailbox_zone1D'];
		} else {
			$data['shipping_dhlparcel_zone1_cost_mailbox_zone1D'] = $this->config->get('shipping_dhlparcel_zone1_cost_mailbox_zone1D');
		}
		
		if (isset($this->request->post['shipping_dhlparcel_zone1_cost_verysmall_zone1D'])) {
			$data['shipping_dhlparcel_zone1_cost_verysmall_zone1D'] = $this->request->post['shipping_dhlparcel_zone1_cost_verysmall_zone1D'];
		} else {
			$data['shipping_dhlparcel_zone1_cost_verysmall_zone1D'] = $this->config->get('shipping_dhlparcel_zone1_cost_verysmall_zone1D');
		}
		
		if (isset($this->request->post['shipping_dhlparcel_zone1_cost_small_zone1D'])) {
			$data['shipping_dhlparcel_zone1_cost_small_zone1D'] = $this->request->post['shipping_dhlparcel_zone1_cost_small_zone1D'];
		} else {
			$data['shipping_dhlparcel_zone1_cost_small_zone1D'] = $this->config->get('shipping_dhlparcel_zone1_cost_small_zone1D');
		}

		if (isset($this->request->post['shipping_dhlparcel_zone1_cost_medium_zone1D'])) {
			$data['shipping_dhlparcel_zone1_cost_medium_zone1D'] = $this->request->post['shipping_dhlparcel_zone1_cost_medium_zone1D'];
		} else {
			$data['shipping_dhlparcel_zone1_cost_medium_zone1D'] = $this->config->get('shipping_dhlparcel_zone1_cost_medium_zone1D');
		}
		
		if (isset($this->request->post['shipping_dhlparcel_zone1_cost_large_zone1D'])) {
			$data['shipping_dhlparcel_zone1_cost_large_zone1D'] = $this->request->post['shipping_dhlparcel_zone1_cost_large_zone1D'];
		} else {
			$data['shipping_dhlparcel_zone1_cost_large_zone1D'] = $this->config->get('shipping_dhlparcel_zone1_cost_large_zone1D');
		}
		
		// Spain
		if (isset($this->request->post['shipping_dhlparcel_zone1_cost_mailbox_zone1E'])) {
			$data['shipping_dhlparcel_zone1_cost_mailbox_zone1E'] = $this->request->post['shipping_dhlparcel_zone1_cost_mailbox_zone1E'];
		} else {
			$data['shipping_dhlparcel_zone1_cost_mailbox_zone1E'] = $this->config->get('shipping_dhlparcel_zone1_cost_mailbox_zone1E');
		}
		
		if (isset($this->request->post['shipping_dhlparcel_zone1_cost_verysmall_zone1E'])) {
			$data['shipping_dhlparcel_zone1_cost_verysmall_zone1E'] = $this->request->post['shipping_dhlparcel_zone1_cost_verysmall_zone1E'];
		} else {
			$data['shipping_dhlparcel_zone1_cost_verysmall_zone1E'] = $this->config->get('shipping_dhlparcel_zone1_cost_verysmall_zone1E');
		}
		
		if (isset($this->request->post['shipping_dhlparcel_zone1_cost_small_zone1E'])) {
			$data['shipping_dhlparcel_zone1_cost_small_zone1E'] = $this->request->post['shipping_dhlparcel_zone1_cost_small_zone1E'];
		} else {
			$data['shipping_dhlparcel_zone1_cost_small_zone1E'] = $this->config->get('shipping_dhlparcel_zone1_cost_small_zone1E');
		}

		if (isset($this->request->post['shipping_dhlparcel_zone1_cost_medium_zone1E'])) {
			$data['shipping_dhlparcel_zone1_cost_medium_zone1E'] = $this->request->post['shipping_dhlparcel_zone1_cost_medium_zone1E'];
		} else {
			$data['shipping_dhlparcel_zone1_cost_medium_zone1E'] = $this->config->get('shipping_dhlparcel_zone1_cost_medium_zone1E');
		}
		
		if (isset($this->request->post['shipping_dhlparcel_zone1_cost_large_zone1E'])) {
			$data['shipping_dhlparcel_zone1_cost_large_zone1E'] = $this->request->post['shipping_dhlparcel_zone1_cost_large_zone1E'];
		} else {
			$data['shipping_dhlparcel_zone1_cost_large_zone1E'] = $this->config->get('shipping_dhlparcel_zone1_cost_large_zone1E');
		}




		// Rest of Europe - Zone 2 
		
		if (isset($this->request->post['shipping_dhlparcel_zone2_cost_mailbox'])) {
			$data['shipping_dhlparcel_zone2_cost_mailbox'] = $this->request->post['shipping_dhlparcel_zone2_cost_mailbox'];
		} else {
			$data['shipping_dhlparcel_zone2_cost_mailbox'] = $this->config->get('shipping_dhlparcel_zone2_cost_mailbox');
		}
		
		if (isset($this->request->post['shipping_dhlparcel_zone2_cost_verysmall'])) {
			$data['shipping_dhlparcel_zone2_cost_verysmall'] = $this->request->post['shipping_dhlparcel_zone2_cost_verysmall'];
		} else {
			$data['shipping_dhlparcel_zone2_cost_verysmall'] = $this->config->get('shipping_dhlparcel_zone2_cost_verysmall');
		}
		
		if (isset($this->request->post['shipping_dhlparcel_zone2_cost_small'])) {
			$data['shipping_dhlparcel_zone2_cost_small'] = $this->request->post['shipping_dhlparcel_zone2_cost_small'];
		} else {
			$data['shipping_dhlparcel_zone2_cost_small'] = $this->config->get('shipping_dhlparcel_zone2_cost_small');
		}
		
		if (isset($this->request->post['shipping_dhlparcel_zone2_cost_medium'])) {
			$data['shipping_dhlparcel_zone2_cost_medium'] = $this->request->post['shipping_dhlparcel_zone2_cost_medium'];
		} else {
			$data['shipping_dhlparcel_zone2_cost_medium'] = $this->config->get('shipping_dhlparcel_zone2_cost_medium');
		}
		
		if (isset($this->request->post['shipping_dhlparcel_zone2_cost_large'])) {
			$data['shipping_dhlparcel_zone2_cost_large'] = $this->request->post['shipping_dhlparcel_zone2_cost_large'];
		} else {
			$data['shipping_dhlparcel_zone2_cost_large'] = $this->config->get('shipping_dhlparcel_zone2_cost_large');
		}
		
		// Norway and Switserland
		if (isset($this->request->post['shipping_dhlparcel_zone2_cost_mailbox_zone2a'])) {
			$data['shipping_dhlparcel_zone2_cost_mailbox_zone2a'] = $this->request->post['shipping_dhlparcel_zone2_cost_mailbox_zone2a'];
		} else {
			$data['shipping_dhlparcel_zone2_cost_mailbox_zone2a'] = $this->config->get('shipping_dhlparcel_zone2_cost_mailbox_zone2a');
		}
		
		// Holy See, Vatican City
		if (isset($this->request->post['shipping_dhlparcel_zone2_cost_mailbox_zone2b'])) {
			$data['shipping_dhlparcel_zone2_cost_mailbox_zone2b'] = $this->request->post['shipping_dhlparcel_zone2_cost_mailbox_zone2b'];
		} else {
			$data['shipping_dhlparcel_zone2_cost_mailbox_zone2b'] = $this->config->get('shipping_dhlparcel_zone2_cost_mailbox_zone2b');
		}

		// Rest of the World - Zone 3
		
		if (isset($this->request->post['shipping_dhlparcel_zone3_cost_mailbox'])) {
			$data['shipping_dhlparcel_zone3_cost_mailbox'] = $this->request->post['shipping_dhlparcel_zone3_cost_mailbox'];
		} else {
			$data['shipping_dhlparcel_zone3_cost_mailbox'] = $this->config->get('shipping_dhlparcel_zone3_cost_mailbox');
		}
		
		if (isset($this->request->post['shipping_dhlparcel_zone3_cost_verysmall'])) {
			$data['shipping_dhlparcel_zone3_cost_verysmall'] = $this->request->post['shipping_dhlparcel_zone3_cost_verysmall'];
		} else {
			$data['shipping_dhlparcel_zone3_cost_verysmall'] = $this->config->get('shipping_dhlparcel_zone3_cost_verysmall');
		}
		
		if (isset($this->request->post['shipping_dhlparcel_zone3_cost_small'])) {
			$data['shipping_dhlparcel_zone3_cost_small'] = $this->request->post['shipping_dhlparcel_zone3_cost_small'];
		} else {
			$data['shipping_dhlparcel_zone3_cost_small'] = $this->config->get('shipping_dhlparcel_zone3_cost_small');
		}
		
		if (isset($this->request->post['shipping_dhlparcel_zone3_cost_medium'])) {
			$data['shipping_dhlparcel_zone3_cost_medium'] = $this->request->post['shipping_dhlparcel_zone3_cost_medium'];
		} else {
			$data['shipping_dhlparcel_zone3_cost_medium'] = $this->config->get('shipping_dhlparcel_zone3_cost_medium');
		}
		
		if (isset($this->request->post['shipping_dhlparcel_zone3_cost_large'])) {
			$data['shipping_dhlparcel_zone3_cost_large'] = $this->request->post['shipping_dhlparcel_zone3_cost_large'];
		} else {
			$data['shipping_dhlparcel_zone3_cost_large'] = $this->config->get('shipping_dhlparcel_zone3_cost_large');
		}

		// Settings
		if (isset($this->request->post['shipping_dhlparcel_use_freeshipping'])) {
			$data['shipping_dhlparcel_use_freeshipping'] = $this->request->post['shipping_dhlparcel_use_freeshipping'];
		} else {
			$data['shipping_dhlparcel_use_freeshipping'] = $this->config->get('shipping_dhlparcel_use_freeshipping');
		}

		if (isset($this->request->post['shipping_dhlparcel_total'])) {
			$data['shipping_dhlparcel_total'] = $this->request->post['shipping_dhlparcel_total'];
		} else {
			$data['shipping_dhlparcel_total'] = $this->config->get('shipping_dhlparcel_total');
		}
		
		if (isset($this->request->post['shipping_dhlparcel_use_mailbox'])) {
			$data['shipping_dhlparcel_use_mailbox'] = $this->request->post['shipping_dhlparcel_use_mailbox'];
		} else {
			$data['shipping_dhlparcel_use_mailbox'] = $this->config->get('shipping_dhlparcel_use_mailbox');
		}

		if (isset($this->request->post['shipping_dhlparcel_total'])) {
			$data['shipping_dhlparcel_total'] = $this->request->post['shipping_dhlparcel_total'];
		} else {
			$data['shipping_dhlparcel_total'] = $this->config->get('shipping_dhlparcel_total');
		}
		
		$this->load->model('localisation/tax_class');

		$data['tax_classes'] = $this->model_localisation_tax_class->getTaxClasses();

		if (isset($this->request->post['shipping_dhlparcel_geo_zone_id'])) {
			$data['shipping_dhlparcel_geo_zone_id'] = $this->request->post['shipping_dhlparcel_geo_zone_id'];
		} else {
			$data['shipping_dhlparcel_geo_zone_id'] = $this->config->get('shipping_dhlparcel_geo_zone_id');
		}

		if (isset($this->request->post['shipping_dhlparcel_tax_class_id'])) {
			$data['shipping_dhlparcel_tax_class_id'] = $this->request->post['shipping_dhlparcel_tax_class_id'];
		} else {
			$data['shipping_dhlparcel_tax_class_id'] = $this->config->get('shipping_dhlparcel_tax_class_id');
		}
		
		$this->load->model('localisation/geo_zone');

		$data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();
		
		if (isset($this->request->post['shipping_dhlparcel_status'])) {
			$data['shipping_dhlparcel_status'] = $this->request->post['shipping_dhlparcel_status'];
		} else {
			$data['shipping_dhlparcel_status'] = $this->config->get('shipping_dhlparcel_status');
		}

		if (isset($this->request->post['shipping_dhlparcel_sort_order'])) {
			$data['shipping_dhlparcel_sort_order'] = $this->request->post['shipping_dhlparcel_sort_order'];
		} else {
			$data['shipping_dhlparcel_sort_order'] = $this->config->get('shipping_dhlparcel_sort_order');
		}

		// Brievenbus formaten
		if (isset($this->request->post['shipping_dhlparcel_mailbox_lenght'])) {
			$data['shipping_dhlparcel_mailbox_lenght'] = $this->request->post['shipping_dhlparcel_mailbox_lenght'];
		} else {
			$data['shipping_dhlparcel_mailbox_lenght'] = $this->config->get('shipping_dhlparcel_mailbox_lenght');
		}
		
		if (isset($this->request->post['shipping_dhlparcel_mailbox_width'])) {
			$data['shipping_dhlparcel_mailbox_width'] = $this->request->post['shipping_dhlparcel_mailbox_width'];
		} else {
			$data['shipping_dhlparcel_mailbox_width'] = $this->config->get('shipping_dhlparcel_mailbox_width');
		}
		
		if (isset($this->request->post['shipping_dhlparcel_mailbox_height'])) {
			$data['shipping_dhlparcel_mailbox_height'] = $this->request->post['shipping_dhlparcel_mailbox_height'];
		} else {
			$data['shipping_dhlparcel_mailbox_height'] = $this->config->get('shipping_dhlparcel_mailbox_height');
		}
		
		if (isset($this->request->post['shipping_dhlparcel_mailbox_weight'])) {
			$data['shipping_dhlparcel_mailbox_weight'] = $this->request->post['shipping_dhlparcel_mailbox_weight'];
		} else {
			$data['shipping_dhlparcel_mailbox_weight'] = $this->config->get('shipping_dhlparcel_mailbox_weight');
		}


		// Verzenddoos formaten
		if (isset($this->request->post['shipping_dhlparcel_cardboard_box_lenght'])) {
			$data['shipping_dhlparcel_cardboard_box_lenght'] = $this->request->post['shipping_dhlparcel_cardboard_box_lenght'];
		} else {
			$data['shipping_dhlparcel_cardboard_box_lenght'] = $this->config->get('shipping_dhlparcel_cardboard_box_lenght');
		}
		
		if (isset($this->request->post['shipping_dhlparcel_cardboard_box_width'])) {
			$data['shipping_dhlparcel_cardboard_box_width'] = $this->request->post['shipping_dhlparcel_cardboard_box_width'];
		} else {
			$data['shipping_dhlparcel_cardboard_box_width'] = $this->config->get('shipping_dhlparcel_cardboard_box_width');
		}
		
		if (isset($this->request->post['shipping_dhlparcel_cardboard_box_height'])) {
			$data['shipping_dhlparcel_cardboard_box_height'] = $this->request->post['shipping_dhlparcel_cardboard_box_height'];
		} else {
			$data['shipping_dhlparcel_cardboard_box_height'] = $this->config->get('shipping_dhlparcel_cardboard_box_height');
		}
		
		if (isset($this->request->post['shipping_dhlparcel_cardboard_box_weight'])) {
			$data['shipping_dhlparcel_cardboard_box_weight'] = $this->request->post['shipping_dhlparcel_cardboard_box_weight'];
		} else {
			$data['shipping_dhlparcel_cardboard_box_weight'] = $this->config->get('shipping_dhlparcel_cardboard_box_weight');
		}


		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');
		
		$this->response->setOutput($this->load->view('extension/shipping/dhlparcel', $data));
	}
	
	
	protected function validate() {
		if (!$this->user->hasPermission('modify', 'extension/shipping/dhlparcel')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		return !$this->error;
	}
	
	
}
