<?php
/*
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

   ---------------------------------------------------------------------
   Gerrit Bouweriks
   Dutch DHL Parcel + International Shipping
   OpenCart 3.0.2.0
   Special thank you goes to
   Roelie of PprMkr for helping me out.
   SuperJuice (Sam), for conversions made to weight en length classes
   Sanne, Gijs and Cliff for testing and Norman for the translations
   Petran for old letterbox solution
   This new version uses a modified boxing.class.php as a letterbox solution.
   I was pointed out to this class by Ivo, another Dutch OpenCart user.
   https://github.com/yetzt/boxing/blob/master/boxing.class.php
*/
class ModelExtensionShippingDHLparcel extends Model {
	function getQuote($address) {
		$this->load->language('extension/shipping/dhlparcel');
		
		if ($this->config->get('shipping_dhlparcel_status')) {
      		//$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "zone_to_geo_zone WHERE geo_zone_id = '" . (int)$this->config->get('shipping_dhlparcel_geo_zone_id') . "' AND country_id = '" . (int)$address['country_id'] . "' AND (zone_id = '" . (int)$address['zone_id'] . "' OR zone_id = '0')");
			$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "zone_to_geo_zone WHERE geo_zone_id = '" . (int)$this->config->get('shipping_dhlparcel_geo_zone_id') . "' AND country_id = '" . (int)$address['country_id'] . "' AND (zone_id = '" . (int)$address['zone_id'] . "' OR zone_id = '0')");
      		if (!$this->config->get('shipping_dhlparcel_geo_zone_id')) {
        		$status = TRUE;
      		} elseif ($query->num_rows) {
        		$status = TRUE;
      		} else {
        		$status = FALSE;
      		}
		} else {
			$status = FALSE;
		}
	
		if ($this->config->get('shipping_dhlparcel_use_freeshipping')) {
			if ($address['iso_code_2'] === 'NL') {
				if ($this->cart->getSubTotal() > $this->config->get('free_total')) {
					$status = false;
				}
			}
		}

		$verzendkosten = 0;
		$error = FALSE;
		$quote_data = array();
		$dhlparcel_box = false;
		$mailbox = false;
		
				
		if ($status) {
		
		
			//Query to find id of grams (g) as 1.5.1.1 removed the availability of the named unit
			$unit_query =  $this->db->query("SELECT weight_class_id FROM " . DB_PREFIX . "weight_class_description where LOWER(unit) = 'g'");

			if ($unit_query->num_rows) {$unit_g = $unit_query->row['weight_class_id'];}

			$weight = round((float) ($this->weight->convert($this->cart->getWeight(), $this->config->get('config_weight_class_id'), $unit_g)), 2);
			if ($weight >= 1000) {
				$show_weight = round((float) ($weight / 1000),2);

				$kg = $this->language->get('text_showweight_gram');
			}

			if ($weight < 1000) {
				$show_weight = floatval($this->weight->convert($this->cart->getWeight(), $this->config->get('config_weight_class_id'), $unit_g));
				$kg = $this->language->get('text_showweight_gram');
			}				

			// subtotaal van het karretje exclusief BTW
			$sub_total = $this->cart->getSubTotal();
				 	

		
			// Maximaal te versturen pakketten, voor volgende versie
			$max_parcels = 1;
			
			// Zet alle maten voorlopig op 0			
			$stuk_lenght = 0;
			$stuk_width = 0;
			$stuk_height = 0;
			
			$dhlparcel_box = true;				
 			
 			$cost = 0;
 				
 			if ($this->config->get('shipping_dhlparcel_cardboard_box_lenght')) {
 				$boxlenght = $this->config->get('shipping_dhlparcel_cardboard_box_lenght');
 			} else { $boxlenght = 800; }
 							
 			if ($this->config->get('shipping_dhlparcel_cardboard_box_width')) {
 				$boxwidth = $this->config->get('shipping_dhlparcel_cardboard_box_width');
 			} else { $boxwidth = 400; }
 			
 			if ($this->config->get('shipping_dhlparcel_cardboard_box_height')) {
 				$boxheight = $this->config->get('shipping_dhlparcel_cardboard_box_height');
 			} else { $boxheight = 350; }
 				
 			if ($this->config->get('shipping_dhlparcel_cardboard_box_weight')) {
 				$boxweight = $this->config->get('shipping_dhlparcel_cardboard_box_weight');
 			} else { $boxweight = 300; }
 		
 		
 				
 			if ($this->config->get('shipping_dhlparcel_use_mailbox') == 1) {
 				$cost = 0;
 				
 				if ($this->config->get('shipping_dhlparcel_mailbox_lenght')) {
 					$boxlenght = $this->config->get('shipping_dhlparcel_mailbox_lenght');
 				} else { $boxlenght = 380; }
 							
 				if ($this->config->get('shipping_dhlparcel_mailbox_width')) {
 					$boxwidth = $this->config->get('shipping_dhlparcel_mailbox_width');
 				} else { $boxwidth = 260; }
 			
 				if ($this->config->get('shipping_dhlparcel_mailbox_height')) {
 					$boxheight = $this->config->get('shipping_dhlparcel_mailbox_height');
 				} else { $boxheight = 30; }
 			
 				if ($this->config->get('shipping_dhlparcel_mailbox_weight')) {
 					$boxweight = $this->config->get('shipping_dhlparcel_mailbox_weight');
 				} else { $boxweight = 100; }
 		
 			}
 		
 				
 			if ($this->config->get('shipping_dhlparcel_use_mailbox') == 1) {
 				//$mailbox = true;	
 				require_once(DIR_APPLICATION . 'model/extension/shipping/dhlparcel_boxing.class.php');
 				$mailbox = true;
 				$b = new boxing();
 				$b -> add_outer_box($boxlenght,$boxwidth,$boxheight);
 			
 			
 
 				// Query to find out if mm are configured in the database because OpenCart developers thought it wasn't needed in the API (currently no error condition if it doesn't exist)
 				$unit_query =  $this->db->query("SELECT length_class_id FROM " . DB_PREFIX . "length_class_description where LOWER(unit) = 'mm'");
 
 				if ($unit_query->num_rows) {$unit_mm = $unit_query->row['length_class_id'];}
 
 				foreach ($this->cart->getProducts() as $cartitem) {
 				
 				if($cartitem['width'] != 0) {
 					$cartitem['width'] = $this->length->convert($cartitem['width'], $cartitem['length_class_id'], $unit_mm);
 				} else {
 					$cartitem['width'] = 100;
 				}
 
 				if($cartitem['height'] != 0) {
 					$cartitem['height'] = $this->length->convert($cartitem['height'], $cartitem['length_class_id'], $unit_mm);
 				} else {
 					$cartitem['height'] = 100;
 				}
 
 				if($cartitem['length'] != 0) {
 					$cartitem['length'] = $this->length->convert($cartitem['length'], $cartitem['length_class_id'], $unit_mm);
 				} else {
 					$cartitem['length'] = 100;
 				}
 
 				for ($i = 1; $i <= $cartitem['quantity']; $i++) $b -> add_inner_box($cartitem['length'], $cartitem['width'], $cartitem['height']);
 
 			}
 			// eind formaat bepaling brievenbus pakketje
 			if (!$b -> fits()) {
 			$mailbox = false;
 		}	
 		}
 		
 		// brievenbus pakketje is te klein
 		
 		//if (!$b -> fits()) {
 		//	$mailbox = false;
 		//}
 		
 		
 		if ($mailbox == false || $this->config->get('shipping_dhlparcel_use_mailbox') == 0) {
 				$mailbox = false;
 				
 				if ($this->config->get('shipping_dhlparcel_cardboard_box_lenght')) {
 					$boxlenght = $this->config->get('shipping_dhlparcel_cardboard_box_lenght');
 				} else { $boxlenght = 800; }
 							
 				if ($this->config->get('shipping_dhlparcel_cardboard_box_width')) {
 					$boxwidth = $this->config->get('shipping_dhlparcel_cardboard_box_width');
 				} else { $boxwidth = 400; }
 			
 				if ($this->config->get('shipping_dhlparcel_cardboard_box_height')) {
 					$boxheight = $this->config->get('shipping_dhlparcel_cardboard_box_height');
 				} else { $boxheight = 350; }
 				
 				if ($this->config->get('shipping_dhlparcel_cardboard_box_weight')) {
 					$boxweight = $this->config->get('shipping_dhlparcel_cardboard_box_weight');
 				} else { $boxweight = 300; }
 		
 				require_once(DIR_APPLICATION . 'model/extension/shipping/dhlparcel_boxing.class.php');
 				$mailbox = false;
 				$b = new boxing();
 				$b -> add_outer_box($boxlenght,$boxwidth,$boxheight);
 			
 			 // Query to find out if mm are configured in the database because OpenCart developers thought it wasn't needed in the API (currently no error condition if it doesn't exist)
 			$unit_query =  $this->db->query("SELECT length_class_id FROM " . DB_PREFIX . "length_class_description where LOWER(unit) = 'mm'");
 
 			if ($unit_query->num_rows) {$unit_mm = $unit_query->row['length_class_id'];}
 
 			foreach ($this->cart->getProducts() as $cartitem) {
 				//if($cartitem['length_class_id'] != $unit_mm) {
 
 				if($cartitem['width'] != 0) {
 					$cartitem['width'] = $this->length->convert($cartitem['width'], $cartitem['length_class_id'], $unit_mm);
 				} else {
 					$cartitem['width'] = 100;
 				}
 
 				if($cartitem['height'] != 0) {
 					$cartitem['height'] = $this->length->convert($cartitem['height'], $cartitem['length_class_id'], $unit_mm);
 				} else {
 					$cartitem['height'] = 100;
 				}
 
 				if($cartitem['length'] != 0) {
 					$cartitem['length'] = $this->length->convert($cartitem['length'], $cartitem['length_class_id'], $unit_mm);
 				} else {
 					$cartitem['length'] = 100;
 				}
 
 				for ($i = 1; $i <= $cartitem['quantity']; $i++) $b -> add_inner_box($cartitem['length'], $cartitem['width'], $cartitem['height']);
 
 			}
 			// eind formaat bepaling pakket
 			//$cardboardbox = 1;
 		}
 			
 		
 		
 		// Brievenbus als deze aan staat 		
 		// het past in een brievenbus doosje
 		// Nederland
 		if ($mailbox == true) {
 			$weight = $weight + $boxweight;
 		
 			// als het past binen de opgegeven doos formaten voor Nederland
 			 if ($b -> fits() && $address['iso_code_2'] == 'NL' && $weight < 2000) {
  				$dhlparcel_box = true;

 				if ($weight < 2000){
 					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
 					$title = $this->language->get('text_dhlparcel_mailbox_parcel');
 					$verzendkosten = $this->config->get('shipping_dhlparcel_netherlands_cost_mailbox');
 				}
 						
 				if ($weight <= $boxweight) {
 					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
 					$title = $this->language->get('text_dhlparcel_title');
 					$error = $this->language->get('text_dhlparcel_error_zero_weight');
 				}
 				
 				if ($weight > 2000) {
 					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
 					$title = $this->language->get('text_dhlparcel_title');
 					$error = $this->language->get('text_dhlparcel_error_max_weight');
 				}
 				 			
 				$quote_data['shipping_dhlparcel_netherlands_cost_mailbox'] = array(
 					'code' => 'dhlparcel.shipping_dhlparcel_netherlands_cost_mailbox',
 					'title' => $title,
 					'cost' => $verzendkosten,
 					'tax_class_id' => $this->config->get('shipping_dhlparcel_tax_class_id'),
 					'text' => $this->currency->format($this->tax->calculate($verzendkosten, $this->config->get('shipping_dhlparcel_tax_class_id'), $this->config->get('config_tax')), $this->session->data['currency'])
 					);
 			}
 				
 			// Duitsland
 			if ($b -> fits() && $address['iso_code_2'] == 'DE' && $weight < 500) {
  				$dhlparcel_box = true; 			 
 				
 				if ($weight < 500){
 					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
 					$title = $this->language->get('text_dhlparcel_mailbox_parcel');
 					$verzendkosten = $this->config->get('shipping_dhlparcel_zone1_cost_mailbox_zone1A');
 				}
 						
 				if ($weight <= $boxweight) {
 					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
 					$title = $this->language->get('text_dhlparcel_title');
 					$error = $this->language->get('text_dhlparcel_error_zero_weight');
 				}
 				
 				if ($weight > 500) {
 					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
 					$title = $this->language->get('text_dhlparcel_title');
 					$error = $this->language->get('text_dhlparcel_error_max_weight');
 				}
 				 			
 				$quote_data['shipping_dhlparcel_zone1_cost_mailbox_zone1A'] = array(
 					'code' => 'dhlparcel.shipping_dhlparcel_zone1_cost_mailbox_zone1A',
 					'title' => $title,
 					'cost' => $verzendkosten,
 					'tax_class_id' => $this->config->get('shipping_dhlparcel_tax_class_id'),
 					'text' => $this->currency->format($this->tax->calculate($verzendkosten, $this->config->get('shipping_dhlparcel_tax_class_id'), $this->config->get('config_tax')), $this->session->data['currency'])
 					);
 			}
 							
 			// zone 1B
 			$countries = explode(',', 'BE,LU');
 						
			if (in_array($address['iso_code_2'], $countries) && $b -> fits() && $weight < 500 ) {
  				
  				$dhlparcel_box = true;
  			 
 				if ($weight < 500){
 					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
 					$title = $this->language->get('text_dhlparcel_mailbox_parcel');
 					$verzendkosten = $this->config->get('shipping_dhlparcel_zone1_cost_mailbox_zone1B');
 				}
 						
 				if ($weight <= $boxweight) {
 					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
 					$title = $this->language->get('text_dhlparcel_title');
 					$error = $this->language->get('text_dhlparcel_error_zero_weight');
 				}
 				
 				if ($weight > 500) {
 					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
 					$title = $this->language->get('text_dhlparcel_title');
 					$error = $this->language->get('text_dhlparcel_error_max_weight');
 				}
 				 			
 				$quote_data['shipping_dhlparcel_zone1_cost_mailbox_zone1B'] = array(
 					'code' => 'dhlparcel.shipping_dhlparcel_zone1_cost_mailbox_zone1B',
 					'title' => $title,
 					'cost' => $verzendkosten,
 					'tax_class_id' => $this->config->get('shipping_dhlparcel_tax_class_id'),
 					'text' => $this->currency->format($this->tax->calculate($verzendkosten, $this->config->get('shipping_dhlparcel_tax_class_id'), $this->config->get('config_tax')), $this->session->data['currency'])
 					);
 			}
 			
 			// zone 1C
 			$countries = explode(',', 'DK,FR,GB,IT,AT,SE');
 						
			if (in_array($address['iso_code_2'], $countries) && $b -> fits() && $weight < 500) {
  				$dhlparcel_box = true;
  			 
 				if ($weight < 500){
 					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
 					$title = $this->language->get('text_dhlparcel_mailbox_parcel');
 					$verzendkosten = $this->config->get('shipping_dhlparcel_zone1_cost_mailbox_zone1C');
 				}
 						
 				if ($weight <= $boxweight) {
 					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
 					$title = $this->language->get('text_dhlparcel_title');
 					$error = $this->language->get('text_dhlparcel_error_zero_weight');
 				}
 				
 				if ($weight > 500) {
 					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
 					$title = $this->language->get('text_dhlparcel_title');
 					$error = $this->language->get('text_dhlparcel_error_max_weight');
 				}
 				 			
 				$quote_data['shipping_dhlparcel_zone1_cost_mailbox_zone1C'] = array(
 					'code' => 'dhlparcel.shipping_dhlparcel_zone1_cost_mailbox_zone1C',
 					'title' => $title,
 					'cost' => $verzendkosten,
 					'tax_class_id' => $this->config->get('shipping_dhlparcel_tax_class_id'),
 					'text' => $this->currency->format($this->tax->calculate($verzendkosten, $this->config->get('shipping_dhlparcel_tax_class_id'), $this->config->get('config_tax')), $this->session->data['currency'])
 					);
 			}
 			
 			// zone 1D
 			$countries = explode(',', 'FI,IR,PL,PT');
 						
			if (in_array($address['iso_code_2'], $countries) && $b -> fits() && $weight < 500) {
  				$dhlparcel_box = true;
  			 
 				if ($weight < 500){
 					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
 					$title = $this->language->get('text_dhlparcel_mailbox_parcel');
 					$verzendkosten = $this->config->get('shipping_dhlparcel_zone1_cost_mailbox_zone1D');
 				}
 						
 				if ($weight <= $boxweight) {
 					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
 					$title = $this->language->get('text_dhlparcel_title');
 					$error = $this->language->get('text_dhlparcel_error_zero_weight');
 				}
 				
 				if ($weight > 500) {
 					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
 					$title = $this->language->get('text_dhlparcel_title');
 					$error = $this->language->get('text_dhlparcel_error_max_weight');
 				}
 				 			
 				$quote_data['shipping_dhlparcel_zone1_cost_mailbox_zone1D'] = array(
 					'code' => 'dhlparcel.shipping_dhlparcel_zone1_cost_mailbox_zone1D',
 					'title' => $title,
 					'cost' => $verzendkosten,
 					'tax_class_id' => $this->config->get('shipping_dhlparcel_tax_class_id'),
 					'text' => $this->currency->format($this->tax->calculate($verzendkosten, $this->config->get('shipping_dhlparcel_tax_class_id'), $this->config->get('config_tax')), $this->session->data['currency'])
 					);
 			}			 			
 			
 			// als het past binen de opgegeven doos formaten voor Spanje
 			 if ($b -> fits() && $address['iso_code_2'] == 'ES' && $weight < 500) {
  				$dhlparcel_box = true;

 				if ($weight < 500){
 					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
 					$title = $this->language->get('text_dhlparcel_mailbox_parcel');
 					$verzendkosten = $this->config->get('shipping_dhlparcel_zone1_cost_mailbox_zone1E');
 				}
 						
 				if ($weight <= $boxweight) {
 					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
 					$title = $this->language->get('text_dhlparcel_title');
 					$error = $this->language->get('text_dhlparcel_error_zero_weight');
 				}
 				
 				if ($weight > 500) {
 					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
 					$title = $this->language->get('text_dhlparcel_title');
 					$error = $this->language->get('text_dhlparcel_error_max_weight');
 				}
 				 			
 				$quote_data['shipping_dhlparcel_zone1_cost_mailbox_zone1E'] = array(
 					'code' => 'dhlparcel.shipping_dhlparcel_zone1_cost_mailbox_zone1E',
 					'title' => $title,
 					'cost' => $verzendkosten,
 					'tax_class_id' => $this->config->get('shipping_dhlparcel_tax_class_id'),
 					'text' => $this->currency->format($this->tax->calculate($verzendkosten, $this->config->get('shipping_dhlparcel_tax_class_id'), $this->config->get('config_tax')), $this->session->data['currency'])
 					);
 			}
 				
 			// Zone 2
 			$countries = explode(',', 'AX,AL,AD,BY,BA,BG,BV,CY,EE,GI,GR,HU,HR,LV,LI,LT,MC,ME,MK,MT,MD,RO,SM,RS,SI,SK,CZ,TR');
			if (in_array($address['iso_code_2'], $countries) && $b -> fits() & $weight < 500) {
  				$dhlparcel_box = true;

 				if ($weight < 500){
 					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
 					$title = $this->language->get('text_dhlparcel_mailbox_parcel');
 					$verzendkosten = $this->config->get('shipping_dhlparcel_zone2_cost_mailbox');
 				}
 						
 				if ($weight <= $boxweight) {
 					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
 					$title = $this->language->get('text_dhlparcel_title');
 					$error = $this->language->get('text_dhlparcel_error_zero_weight');
 				}
 				
 				if ($weight > 500) {
 					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
 					$title = $this->language->get('text_dhlparcel_title');
 					$error = $this->language->get('text_dhlparcel_error_max_weight');
 				}
 				 			
 				$quote_data['shipping_dhlparcel_zone2_cost_mailbox'] = array(
 					'code' => 'dhlparcel.shipping_dhlparcel_zone2_cost_mailbox',
 					'title' => $title,
 					'cost' => $verzendkosten,
 					'tax_class_id' => $this->config->get('shipping_dhlparcel_tax_class_id'),
 					'text' => $this->currency->format($this->tax->calculate($verzendkosten, $this->config->get('shipping_dhlparcel_tax_class_id'), $this->config->get('config_tax')), $this->session->data['currency'])
 					);
 			}
 			
 			// Noorwegen en Zwitserland	
 			$countries = explode(',', 'NO,CH');
 			if (in_array($address['iso_code_2'], $countries) && $b -> fits() & $weight < 500) {
  				$dhlparcel_box = true;
  			 
 				//$weight = $weight + $boxweight;
 				if ($weight < 500){
 					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
 					$title = $this->language->get('text_dhlparcel_mailbox_parcel');
 					$verzendkosten = $this->config->get('shipping_dhlparcel_zone2_cost_mailbox_zone2a');
 				}
 						
 				if ($weight <= $boxweight) {
 					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
 					$title = $this->language->get('text_dhlparcel_title');
 					$error = $this->language->get('text_dhlparcel_error_zero_weight');
 				}
 				
 				if ($weight > 500) {
 					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
 					$title = $this->language->get('text_dhlparcel_title');
 					$error = $this->language->get('text_dhlparcel_error_max_weight');
 				}
 				 			
 				$quote_data['shipping_dhlparcel_zone2_cost_mailbox_zone2a'] = array(
 					'code' => 'dhlparcel.shipping_dhlparcel_zone2_cost_mailbox_zone2a',
 					'title' => $title,
 					'cost' => $verzendkosten,
 					'tax_class_id' => $this->config->get('shipping_dhlparcel_tax_class_id'),
 					'text' => $this->currency->format($this->tax->calculate($verzendkosten, $this->config->get('shipping_dhlparcel_tax_class_id'), $this->config->get('config_tax')), $this->session->data['currency'])
 					);
 			}
 				
 			// Vaticaan Stad
 			 if ($b -> fits() && $address['iso_code_2'] == 'VA' && $weight < 500) {
  				$dhlparcel_box = true;
  			 
 				//$weight = $weight + $boxweight;
 				if ($weight < 500){
 					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
 					$title = $this->language->get('text_dhlparcel_mailbox_parcel');
 					$verzendkosten = $this->config->get('shipping_dhlparcel_zone2_cost_mailbox_zone2b');
 				}
 						
 				if ($weight <= $boxweight) {
 					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
 					$title = $this->language->get('text_dhlparcel_title');
 					$error = $this->language->get('text_dhlparcel_error_zero_weight');
 				}
 				
 				if ($weight > 500) {
 					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
 					$title = $this->language->get('text_dhlparcel_title');
 					$error = $this->language->get('text_dhlparcel_error_max_weight');
 				}
 				 			
 				$quote_data['shipping_dhlparcel_zone2_cost_mailbox_zone2b'] = array(
 					'code' => 'dhlparcel.shipping_dhlparcel_zone2_cost_mailbox_zone2b',
 					'title' => $title,
 					'cost' => $verzendkosten,
 					'tax_class_id' => $this->config->get('shipping_dhlparcel_tax_class_id'),
 					'text' => $this->currency->format($this->tax->calculate($verzendkosten, $this->config->get('shipping_dhlparcel_tax_class_id'), $this->config->get('config_tax')), $this->session->data['currency'])
 					);
 			}
 				
 				
 			// Zone 3
 			$countries = explode(',', 'NL,DE,BE,LU,FI,IR,PL,PT,DK,FR,GB,IT,AT,SE,AX,AL,AD,BY,BA,BG,BV,CY,EE,GI,GR,HU,HR,LV,LI,LT,MC,ME,MK,MT,MD,NO,RO,SM,RS,SI,SJ,SK,CZ,TR,VA,CH,XK');
 			if (!in_array($address['iso_code_2'], $countries) && $b -> fits() && $weight < 500) {
  				$dhlparcel_box = true;

 				if ($weight < 500){
 					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
 					$title = $this->language->get('text_dhlparcel_mailbox_parcel');
 					$verzendkosten = $this->config->get('shipping_dhlparcel_zone3_cost_mailbox');
 				}
 						
 				if ($weight <= $boxweight) {
 					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
 					$title = $this->language->get('text_dhlparcel_title');
 					$error = $this->language->get('text_dhlparcel_error_zero_weight');
 				}
 				
 				if ($weight > 500) {
 					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
 					$title = $this->language->get('text_dhlparcel_title');
 					$error = $this->language->get('text_dhlparcel_error_max_weight');
 				}
 				 			
 				$quote_data['shipping_dhlparcel_zone3_cost_mailbox'] = array(
 					'code' => 'dhlparcel.shipping_dhlparcel_zone3_cost_mailbox',
 					'title' => $title,
 					'cost' => $verzendkosten,
 					'tax_class_id' => $this->config->get('shipping_dhlparcel_tax_class_id'),
 					'text' => $this->currency->format($this->tax->calculate($verzendkosten, $this->config->get('shipping_dhlparcel_tax_class_id'), $this->config->get('config_tax')), $this->session->data['currency'])
 					);
 			}
 				
 		// eind brievenbus
 		}
		
		// het past niet meer in het brievenbus doosje
		// het is een pakket
			
		if ($this->config->get('shipping_dhlparcel_use_mailbox') == 0 || $mailbox == false)	{		
			
			// DHL Parcel Nederland met brievenbus aangezet	  			 
			if ($address['iso_code_2'] == 'NL') {					  			 
										  			 
			    $dhlparcel_box = true;
			    $cost = 0;
				$weight = $weight + $boxweight;				
				
				if ($weight > $boxweight && $weight <= 2000) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_verysmall_parcel_pickup');				
					$verzendkosten = $this->config->get('shipping_dhlparcel_netherlands_cost_verysmall');
				}
				
				if ($weight > $boxweight && $weight <= 5000) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_small_parcel_pickup');								
					$verzendkosten = $this->config->get('shipping_dhlparcel_netherlands_cost_small');
				}	
				
				if ($weight > 5000 && $weight <= 10000) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_medium_parcel_pickup');				
					$verzendkosten = $this->config->get('shipping_dhlparcel_netherlands_cost_medium');
				}
				
				if ($weight > 10000 && $weight <= 19999) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_large_parcel_pickup');				
					$verzendkosten = $this->config->get('shipping_dhlparcel_netherlands_cost_large');
				}
				
				if ($weight <= $boxweight) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_title');
					$error = $this->language->get('text_dhlparcel_error_zero_weight');
				}
				
				if ($weight > 20000) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_title');
					$error = $this->language->get('text_dhlparcel_error_max_weight');
				}
			
				
				if (!$b -> fits()) {					
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_title');
					$error = $this->language->get('text_dhlparcel_error_max_box');			
				}
								
				$quote_data['shipping_dhlparcel_netherlands_cost'] = array(
					'code' => 'dhlparcel.shipping_dhlparcel_netherlands_cost',
					'title' => $title,
					'cost' => $verzendkosten,
					'tax_class_id' => $this->config->get('shipping_dhlparcel_tax_class_id'),
					'text' => $this->currency->format($this->tax->calculate($verzendkosten, $this->config->get('shipping_dhlparcel_tax_class_id'), $this->config->get('config_tax')), $this->session->data['currency'])
					);
			  
			}
		
							
			// DHL Parcel Zone 1A - west europa
			// Germany
			
			if ($address['iso_code_2'] == 'DE') {				  			 
				
				$dhlparcel_box = true;
				$cost = 0;
				$weight = $weight + $boxweight;		
								
				if ($weight > $boxweight && $weight <= 2000) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_verysmall_parcel');				

					$verzendkosten = $this->config->get('shipping_dhlparcel_zone1_cost_verysmall_zone1A');
				}	
				
				if ($weight > 2000 && $weight <= 5000) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_small_parcel');				

					$verzendkosten = $this->config->get('shipping_dhlparcel_zone1_cost_small_zone1A');
				}	
				
				if ($weight > 5000 && $weight <= 10000) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_medium_parcel');				

					$verzendkosten = $this->config->get('shipping_dhlparcel_zone1_cost_medium_zone1A');
				}
				
				if ($weight > 10000 && $weight <= 19999) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_large_parcel');				

					$verzendkosten = $this->config->get('shipping_dhlparcel_zone1_cost_large_zone1A');
				}
							
				if ($weight <= $boxweight) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_title');
					$error = $this->language->get('text_dhlparcel_error_zero_weight');
				}
				
				if ($weight > 20000) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_title');
					$error = $this->language->get('text_dhlparcel_error_max_weight');
				}
				
				if ($dhlparcel_box == false) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_title');
					$error = $this->language->get('text_dhlparcel_error_max_box');
				}
			
				
				$quote_data['shipping_dhlparcel_zone1A_cost'] = array(
					'code' => 'dhlparcel.shipping_dhlparcel_zone1A_cost',
					'title' => $title,
					'cost' => $verzendkosten,
					'tax_class_id' => $this->config->get('shipping_dhlparcel_tax_class_id'),
					'text' => $this->currency->format($this->tax->calculate($verzendkosten, $this->config->get('shipping_dhlparcel_tax_class_id'), $this->config->get('config_tax')), $this->session->data['currency'])
					);
			
			}
						
			// DHL Parcel Zone 1B - west europa
			// Belgie
									
			$countries = explode(',', 'BE,LU');			
			if (in_array($address['iso_code_2'], $countries)) {
				
				$dhlparcel_box = true;
				$cost = 0;
				$weight = $weight + $boxweight;
								
				if ($weight > $boxweight && $weight <= 2000) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_verysmall_parcel');				
					$verzendkosten = $this->config->get('shipping_dhlparcel_zone1_cost_verysmall_zone1B');
				}	
				
				if ($weight > 2000 && $weight <= 5000) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_small_parcel');				
					$verzendkosten = $this->config->get('shipping_dhlparcel_zone1_cost_small_zone1B');
				}	
				
				if ($weight > 5000 && $weight <= 10000) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_medium_parcel');				
					$verzendkosten = $this->config->get('shipping_dhlparcel_zone1_cost_medium_zone1B');
				}
				
				if ($weight > 10000 && $weight <= 19999) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_large_parcel');				
					$verzendkosten = $this->config->get('shipping_dhlparcel_zone1_cost_large_zone1B');
				}
							
				if ($weight <= $boxweight) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_title');
					$error = $this->language->get('text_dhlparcel_error_zero_weight');
				}
				
				if ($weight > 20000) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_title');
					$error = $this->language->get('text_dhlparcel_error_max_weight');
				}
				
				if ($dhlparcel_box == false) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_title');
					$error = $this->language->get('text_dhlparcel_error_max_box');
				}
				
				$quote_data['shipping_dhlparcel_zone1B_cost'] = array(
					'code' => 'dhlparcel.shipping_dhlparcel_zone1B_cost',
					'title' => $title,
					'cost' => $verzendkosten,
					'tax_class_id' => $this->config->get('shipping_dhlparcel_tax_class_id'),
					'text' => $this->currency->format($this->tax->calculate($verzendkosten, $this->config->get('shipping_dhlparcel_tax_class_id'), $this->config->get('config_tax')), $this->session->data['currency'])
					);	
			}
			
			// DHL Parcel Zone 1C - west europa
			$countries = explode(',', 'DK,FR,GB,IT,AT,SE');		
			if (in_array($address['iso_code_2'], $countries)) {
				
				$dhlparcel_box = true;
				$cost = 0;
				$weight = $weight + $boxweight;
								
				if ($weight > $boxweight && $weight <= 2000) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_verysmall_parcel');				
					$verzendkosten = $this->config->get('shipping_dhlparcel_zone1_cost_verysmall_zone1C');
				}	
				
				if ($weight > 2000 && $weight <= 5000) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_small_parcel');				
					$verzendkosten = $this->config->get('shipping_dhlparcel_zone1_cost_small_zone1C');
				}	
				
				if ($weight > 5000 && $weight <= 10000) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_medium_parcel');				
					$verzendkosten = $this->config->get('shipping_dhlparcel_zone1_cost_medium_zone1C');
				}
				
				if ($weight > 10000 && $weight <= 19999) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_large_parcel');				
					$verzendkosten = $this->config->get('shipping_dhlparcel_zone1_cost_large_zone1C');
				}
							
				if ($weight <= $boxweight) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_title');
					$error = $this->language->get('text_dhlparcel_error_zero_weight');
				}
				
				if ($weight > 20000) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_title');
					$error = $this->language->get('text_dhlparcel_error_max_weight');
				}
				
				if ($dhlparcel_box == false) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_title');
					$error = $this->language->get('text_dhlparcel_error_max_box');
				}
				
				$quote_data['shipping_dhlparcel_zone1C_cost'] = array(
					'code' => 'dhlparcel.shipping_dhlparcel_zone1C_cost',
					'title' => $title,
					'cost' => $verzendkosten,
					'tax_class_id' => $this->config->get('shipping_dhlparcel_tax_class_id'),
					'text' => $this->currency->format($this->tax->calculate($verzendkosten, $this->config->get('shipping_dhlparcel_tax_class_id'), $this->config->get('config_tax')), $this->session->data['currency'])
					);
			}
			
			// DHL Parcel Zone 1D - west europa
			$countries = explode(',', 'FI,IR,PL,PT');
			if (in_array($address['iso_code_2'], $countries)) {
				
				$dhlparcel_box = true;
				$cost = 0;
				$weight = $weight + $boxweight;
								
				if ($weight > $boxweight && $weight <= 2000) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_verysmall_parcel');				
					$verzendkosten = $this->config->get('shipping_dhlparcel_zone1_cost_verysmall_zone1D');
				}	
				
				if ($weight > 2000 && $weight <= 5000) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_small_parcel');				
					$verzendkosten = $this->config->get('shipping_dhlparcel_zone1_cost_small_zone1D');
				}	
				
				if ($weight > 5000 && $weight <= 10000) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_medium_parcel');				
					$verzendkosten = $this->config->get('shipping_dhlparcel_zone1_cost_medium_zone1D');
				}
				
				if ($weight > 10000 && $weight <= 19999) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_large_parcel');				
					$verzendkosten = $this->config->get('shipping_dhlparcel_zone1_cost_large_zone1D');
				}
							
				if ($weight <= $boxweight) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_title');
					$error = $this->language->get('text_dhlparcel_error_zero_weight');
				}
				
				if ($weight > 20000) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_title');
					$error = $this->language->get('text_dhlparcel_error_max_weight');
				}
				
				if ($dhlparcel_box == false) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_title');
					$error = $this->language->get('text_dhlparcel_error_max_box');
				}
				
				$quote_data['shipping_dhlparcel_zone1D_cost'] = array(
					'code' => 'dhlparcel.shipping_dhlparcel_zone1D_cost',
					'title' => $title,
					'cost' => $verzendkosten,
					'tax_class_id' => $this->config->get('shipping_dhlparcel_tax_class_id'),
					'text' => $this->currency->format($this->tax->calculate($verzendkosten, $this->config->get('shipping_dhlparcel_tax_class_id'), $this->config->get('config_tax')), $this->session->data['currency'])
					);
			}
			
			// DHL Parcel Zone 1E - west europa
			// Spanje
			if ($address['iso_code_2'] == 'ES') {		  			 
				
				$dhlparcel_box = true;
				$cost = 0;
				$weight = $weight + $boxweight;
				
				if ($weight > $boxweight && $weight <= 2000) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_verysmall_parcel');				
					$verzendkosten = $this->config->get('shipping_dhlparcel_zone1_cost_verysmall_zone1E');
				}	
				
				if ($weight > 2000 && $weight <= 5000) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_small_parcel');				
					$verzendkosten = $this->config->get('shipping_dhlparcel_zone1_cost_small_zone1E');
				}	
				
				if ($weight > 5000 && $weight <= 10000) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_large_parcel');				
					$verzendkosten = $this->config->get('shipping_dhlparcel_zone1_cost_medium_zone1E');
				}
				
				if ($weight > 10000 && $weight <= 19999) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_large_parcel');				
					$verzendkosten = $this->config->get('shipping_dhlparcel_zone1_cost_large_zone1E');
				}
							
				if ($weight <= $boxweight) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_title');
					$error = $this->language->get('text_dhlparcel_error_zero_weight');
				}
				
				if ($weight > 20000) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_title');
					$error = $this->language->get('text_dhlparcel_error_max_weight');
				}
				
				if ($dhlparcel_box == false) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_title');
					$error = $this->language->get('text_dhlparcel_error_max_box');
				}
				
				$quote_data['shipping_dhlparcel_zone1E_cost'] = array(
					'code' => 'dhlparcel.shipping_dhlparcel_zone1E_cost',
					'title' => $title,
					'cost' => $verzendkosten,
					'tax_class_id' => $this->config->get('shipping_dhlparcel_tax_class_id'),
					'text' => $this->currency->format($this->tax->calculate($verzendkosten, $this->config->get('shipping_dhlparcel_tax_class_id'), $this->config->get('config_tax')), $this->session->data['currency'])
					);
			}			
			
			// DHL Parcel Zone 2 - rest van europa
			$countries = explode(',', 'AX,AL,AD,BY,BA,BG,BV,CY,EE,GI,GR,HU,HR,LV,LI,LT,MC,ME,MK,MT,MD,NO,RO,SM,RS,SI,SJ,SK,CZ,TR,VA,CH');
			if (in_array($address['iso_code_2'], $countries)) {
				
				$dhlparcel_box = true;
				$cost = 0;
				$weight = $weight + $boxweight;
								
				if ($weight > $boxweight && $weight <= 2000) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_verysmall_parcel');				
					$verzendkosten = $this->config->get('shipping_dhlparcel_zone2_cost_verysmall');
				}	
				
				if ($weight > 2000 && $weight <= 5000) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_small_parcel');				
					$verzendkosten = $this->config->get('shipping_dhlparcel_zone2_cost_small');
				}	
				
				if ($weight > 5000 && $weight <= 10000) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_medium_parcel');				
					$verzendkosten = $this->config->get('shipping_dhlparcel_zone2_cost_medium');
				}
				
				if ($weight > 10000 && $weight <= 19999) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_large_parcel');				
					$verzendkosten = $this->config->get('shipping_dhlparcel_zone2_cost_large');
				}
							
				if ($weight <= $boxweight) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_title');
					$error = $this->language->get('text_dhlparcel_error_zero_weight');
				}
				
				if ($weight > 20000) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_title');
					$error = $this->language->get('text_dhlparcel_error_max_weight');
				}
				
				if ($dhlparcel_box == false) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_title');
					$error = $this->language->get('text_dhlparcel_error_max_box');
				}
				
				$quote_data['shipping_dhlparcel_zone2_cost'] = array(
					'code' => 'dhlparcel.shipping_dhlparcel_zone2_cost',
					'title' => $title,
					'cost' => $verzendkosten,
					'tax_class_id' => $this->config->get('shipping_dhlparcel_tax_class_id'),
					'text' => $this->currency->format($this->tax->calculate($verzendkosten, $this->config->get('shipping_dhlparcel_tax_class_id'), $this->config->get('config_tax')), $this->session->data['currency'])
					);
			}
						
			// DHL Parcel Zone 3 - rest van de wereld
			$countries = explode(',', 'NL,BE,LU,DK,DE,FI,FR,IR,GB,IE,IT,AT,PL,PT,ES,SE,AX,AL,AD,BY,BA,BG,BV,CY,EE,GI,GR,HU,HR,LV,LI,LT,MC,ME,MK,MT,MD,NO,RO,SM,RS,SI,SJ,SK,CZ,TR,VA,CH');
			if (!in_array($address['iso_code_2'], $countries)) {
				
				$dhlparcel_box = true;
				$cost = 0;
				$weight = $weight + $boxweight;
								
				if ($weight > $boxweight && $weight <= 2000) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_verysmall_parcel');				
					$verzendkosten = $this->config->get('shipping_dhlparcel_zone3_cost_verysmall');
				}	
				
				if ($weight > 2000 && $weight <= 5000) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_small_parcel');				
					$verzendkosten = $this->config->get('shipping_dhlparcel_zone3_cost_small');
				}	
				
				if ($weight > 5000 && $weight <= 10000) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_medium_parcel');				
					$verzendkosten = $this->config->get('shipping_dhlparcel_zone3_cost_medium');
				}
				
				if ($weight > 10000 && $weight <= 19999) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_large_parcel');				
					$verzendkosten = $this->config->get('shipping_dhlparcel_zone3_cost_large');
				}
							
				if ($weight <= $boxweight) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_title');
					$error = $this->language->get('text_dhlparcel_error_zero_weight');
				}
				
				if ($weight > 20000) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_title');
					$error = $this->language->get('text_dhlparcel_error_max_weight');
				}
				
				if ($dhlparcel_box == false) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_title');
					$error = $this->language->get('text_dhlparcel_error_max_box');
				}
				
				$quote_data['shipping_dhlparcel_zone3_cost'] = array(
					'code' => 'dhlparcel.shipping_dhlparcel_zone3_cost',
					'title' => $title,
					'cost' => $verzendkosten,
					'tax_class_id' => $this->config->get('shipping_dhlparcel_tax_class_id'),
					'text' => $this->currency->format($this->tax->calculate($verzendkosten, $this->config->get('shipping_dhlparcel_tax_class_id'), $this->config->get('config_tax')), $this->session->data['currency'])
					);
			}
			
			// DHL Parcel Nederland met brievenbus aangezet
			if ($this->config->get('shipping_dhlparcel_netherlands_cost_homeaddress') && $address['iso_code_2'] == 'NL') {				  			 
													  			 
			    $dhlparcel_box = true;
			    $cost = 0;
				$weight = $weight + $boxweight;
								
				if ($weight > $boxweight && $weight <= 2000) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_verysmall_parcel_home');
					$homeaddress = $this->config->get('shipping_dhlparcel_netherlands_cost_homeaddress');		
					$verzending = $this->config->get('shipping_dhlparcel_netherlands_cost_verysmall');
					$verzendkosten = $homeaddress + $verzending;
				}
				
				if ($weight > $boxweight && $weight <= 5000) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_small_parcel_home');				
					$homeaddress = $this->config->get('shipping_dhlparcel_netherlands_cost_homeaddress');		
					$verzending = $this->config->get('shipping_dhlparcel_netherlands_cost_small');
					$verzendkosten = $homeaddress + $verzending;
				}
				
				if ($weight > 5000 && $weight <= 10000) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_medium_parcel_home');				
					$homeaddress = $this->config->get('shipping_dhlparcel_netherlands_cost_homeaddress');		
					$verzending = $this->config->get('shipping_dhlparcel_netherlands_cost_medium');
					$verzendkosten = $homeaddress + $verzending;
				}
				
				if ($weight > 10000 && $weight <= 19999) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_large_parcel_home');				
					$homeaddress = $this->config->get('shipping_dhlparcel_netherlands_cost_homeaddress');		
					$verzending = $this->config->get('shipping_dhlparcel_netherlands_cost_large');
					$verzendkosten = $homeaddress + $verzending;
				}
				
				if ($weight <= $boxweight) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_title');
					$error = $this->language->get('text_dhlparcel_error_zero_weight');
				}
				
				if ($weight > 20000) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_title');
					$error = $this->language->get('text_dhlparcel_error_max_weight');
				}
				
				if ($dhlparcel_box == false) {
					$title_dhlparcel = $this->language->get('text_dhlparcel_title');
					$title = $this->language->get('text_dhlparcel_title');
					$error = $this->language->get('text_dhlparcel_error_max_box');
				}
								
				$quote_data['shipping_dhlparcel_netherlands_cost_athome'] = array(
					'code' => 'dhlparcel.shipping_dhlparcel_netherlands_cost_athome',
					'title' => $title,
					'cost' => $verzendkosten,
					'tax_class_id' => $this->config->get('shipping_dhlparcel_tax_class_id'),
					'text' => $this->currency->format($this->tax->calculate($verzendkosten, $this->config->get('shipping_dhlparcel_tax_class_id'), $this->config->get('config_tax')), $this->session->data['currency'])
					);
						
			}
		}	
		// eind berekening welk land en kosten pakket post
	}
	
		
		$method_data = array();

		if ($quote_data) {

			$method_data = array(
				'code' => 'dhlparcel',
				'title' => $this->language->get('text_dhlparcel_title'),
				'quote' => $quote_data,
				'sort_order' => $this->config->get('shipping_dhlparcel_sort_order'),
				'error' => $error
				);
		}
		return $method_data;
	}
}		
// end of DHL Parcel